      *****************************************************************
      *     Data Structure or Pass Area used for calling SIMOHEX4.    *
      *****************************************************************
      *         Copyright (C) 1987-2019 SimoTime Technologies         *
      *                     All Rights Reserved                       *
      *****************************************************************
      *              Provided by SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
      * PASSHEX4-REQUEST - This must contain the following value.     *
      *                    DUMP, Dump Buffer in Hexadecimal format.   *
      * PASSHEX4-RESULT  - Zero indicates a successful completion.    *
      *                    Non-Zero indicates a failure in processing *
      *                    the request.                               *
      * PASSHEX4-LENGTH  - Specifies the length of the text strings   *
      *                    for the PASSHEX4-SOURCE. If the length
      *                    exceeds 1024 then it will be reset to 128. *
      * PASSHEX4-SOURCE  - This is the input field for the SimoHEX4   *
      *                    routine. This field will not be modified.  *
      *                    The contents will be translated into a     *
      *                    haxadecimal format and the results of the  *
      *                    translation will be placed in the          *
      *                    following fields.                          *
      * PASSHEX4-ASCII   - This is a translation of possible ASCII.   *
      * PASSHEX4-UPPER   - This is leftmost (or high order) nibble.   *
      * PASSHEX4-LOWER   - This is rightmost (or low order) nibble.   *
      * PASSHEX4-EBCDIC  - This is a translation of possible EBCDIC.  *
      *****************************************************************
       01  PASSHEX4-PASS-AREA.
      *    The following are provided by the calling program,
           05  PASSHEX4-REQUEST        PIC X(4).
      *    The PASSHEX4-RESULT may be modified by SimoHEX4...
           05  PASSHEX4-RESULT         PIC 9(4).
           05  PASSHEX4-LENGTH         PIC 9(5).
           05  PASSHEX4-SOURCE         PIC X(1024).
      *    The following are modified by SimoHEX4...
           05  PASSHEX4-DUMP-INFO.
               10  PASSHEX4-ASCII      PIC X(1024).
               10  PASSHEX4-UPPER      PIC X(1024).
               10  PASSHEX4-LOWER      PIC X(1024).
               10  PASSHEX4-EBCDIC     PIC X(1024).
      ***  PASSHEX4 - End-of-Copy File - - - - - - - - - - - PASSHEX4 *
      *****************************************************************
      *
