       IDENTIFICATION DIVISION.
       PROGRAM-ID.    TXTHEXC1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: TXTHEXC1.CBL
      * Copy Files:    PASSHEX4.CPY
      * Calls to:      SIMOHEX4.CBL
      *****************************************************************
      *
      * TXTHEXC1 - Execute TXTHEXC1 to read a Sequential file.
      *
      *
      * DESCRIPTION
      * -----------
      * This program will will read a Sequential file and display
      * HEX-Dump information to the console.
      * It will also write the HEX-Dump information to a
      * sequential file.
      *
      *                     ************
      *                     * TXTHEXJ1 *
      *                     ********jcl*
      *                          *
      *                          *
      *                     ************     ************
      *                     * IEFBR14  *-----* SYSHEXT1 *
      *                     ********utl*     ***delete***
      *                          *
      *                          *
      *    ************     ************     ************
      *    * TEXT0512 *-----* TXTHEXC1 *--*--* SYSHEXT1 *
      *    *******ksds*     ********cbl*  *  *******qsam*
      *                          *        *
      *                          *        *
      *                          *        *  ************
      *                          *        **** SIMOHEX4 *
      *                          *           ********cbl*
      *                          *
      *                          *
      *                     ************
      *                     *   EOJ    *
      *                     ************
      *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1996/03/15 Simmons, Created program.
      * 1996/03/15 Simmons, No changes to date.
      *
      *****************************************************************
      *
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT   SECTION.
       FILE-CONTROL.
      *
      *****************************************************************
      ***  FOR VS COBOL II USE THE FOLLOWING...          <----------***
      *
           SELECT TEXT0512-FILE
               ASSIGN       to TEXT0512
               ORGANIZATION is SEQUENTIAL
               ACCESS MODE  is SEQUENTIAL
               FILE STATUS  is TEXT0512-STATUS.
           SELECT SYSHEXT1-FILE
               ASSIGN       to SYSHEXT1
               ORGANIZATION is SEQUENTIAL
               ACCESS MODE  is SEQUENTIAL
               FILE STATUS  is SYSHEXT1-STATUS.

       DATA DIVISION.
       FILE SECTION.
      *
      *****************************************************************
      ***  FOR VS COBOL II USE THE FOLLOWING...          <----------***
       FD  TEXT0512-FILE.

       01  TEXT0512-RECORD.
           05  TEXT0512-DATA      pic X(512).
      *
      *****************************************************************
      ***  FOR VS COBOL II USE THE FOLLOWING...          <----------***
       FD  SYSHEXT1-FILE.
       01  SYSHEXT1-RECORD.
           05  SYSHEXT1-DATA      pic X(128).

       WORKING-STORAGE SECTION.
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *    ------------------------------------------------------------
       01  SIM-TITLE.
           05  T1 pic X(11) value '* TXTHEXC1 '.
           05  T2 pic X(34) value 'HEX-Dump, Sequential or ASCII/Text'.
           05  T3 pic X(10) value ' v08.06.02'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* TXTHEXC1 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* TXTHEXC1 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* TXTHEXC1 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.


       01  TEXT0512-STATUS.
           05  TEXT0512-STAT1      pic X.
           05  TEXT0512-STAT2      pic X.

       01  SYSHEXT1-STATUS.
           05  SYSHEXT1-STAT1      pic X.
           05  SYSHEXT1-STAT2      pic X.

      *****************************************************************
      * The following buffers are used to create a four-byte status   *
      * code that may be displayed.                                   *
      *****************************************************************
       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  IO-STATUS-04.
           05  IO-STATUS-0401      pic 9     value 0.
           05  IO-STATUS-0403      pic 999   value 0.
       01  TWO-BYTES-BINARY        pic 9(4)  BINARY.
       01  TWO-BYTES-ALPHA         redefines TWO-BYTES-BINARY.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.

      *****************************************************************
      *    Buffer used for posting messages to the console.
      *****************************************************************
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* TXTHEXC1 '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

       01  END-OF-FILE             pic X(3)    value 'NO '.

       01  APPL-RESULT             pic S9(9)   comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  FORMAT-TYPE             pic X       value 'B'.

       01  LOWER-CASE  pic X(26) value 'abcdefghijklmnopqrstivwxyz'.
       01  UPPER-CASE  pic X(26) value 'ABCDEFGHIJKLMNOPQRSTIVWXYZ'.

       01  HEX-HEADER.
           05  filler  pic X(20)   value '....+....1....+....2'.
           05  filler  pic X(20)   value '....+....3....+....4'.
           05  filler  pic X(20)   value '....+....5....+....6'.
           05  filler  pic X(20)   value '....+....7....+....8'.

       COPY PASSHEX4.

      *****************************************************************
       LINKAGE SECTION.
       01  PARM-BUFFER.
           05  PARM-LENGTH         pic S9(4)   comp.
           05  PARM-DATA           pic X(256).

      *****************************************************************
       PROCEDURE DIVISION using PARM-BUFFER.

           perform FIRST-TIME-PROCESSING

           perform TEXT0512-OPEN.
           perform SYSHEXT1-OPEN.

           move 'DUMP' to PASSHEX4-REQUEST

           perform until END-OF-FILE = 'YES'
               if  END-OF-FILE = 'NO '
                   perform TEXT0512-GET-NEXT
                   if  END-OF-FILE = 'NO '
                       move TEXT0512-RECORD(1:128) to PASSHEX4-SOURCE
                       perform BUILD-HEX-DUMP-INFO
                       perform ACTION-IS-DISPLAY
                       perform ACTION-IS-WRITE-TO-FILE
                   end-if
               end-if
           end-perform.

           perform TEXT0512-CLOSE.
           perform SYSHEXT1-CLOSE.

           display '* TXTHEXC1 NORMAL-END-OF-JOB' upon console

           perform Z-THANK-YOU.

           GOBACK.

      *****************************************************************
      * The following routines are in alphabetical sequence.          *
      *****************************************************************
       ACTION-IS-DISPLAY.
           display HEX-HEADER
           if  FORMAT-TYPE = 'A'
           or  FORMAT-TYPE = 'B'
               display PASSHEX4-ASCII(1:79)
           end-if
           display PASSHEX4-UPPER(1:79)
           display PASSHEX4-LOWER(1:79)
           if  FORMAT-TYPE = 'E'
           or  FORMAT-TYPE = 'B'
               display PASSHEX4-EBCDIC(1:79)
           end-if

           exit.

      *****************************************************************
       ACTION-IS-WRITE-TO-FILE.
           move    HEX-HEADER to   SYSHEXT1-RECORD
           perform SYSHEXT1-WRITE

           if  FORMAT-TYPE = 'A'
           or  FORMAT-TYPE = 'B'
               move    PASSHEX4-ASCII  to   SYSHEXT1-RECORD
               perform SYSHEXT1-WRITE
           end-if

           move    PASSHEX4-UPPER  to   SYSHEXT1-RECORD
           perform SYSHEXT1-WRITE
           move    PASSHEX4-LOWER  to   SYSHEXT1-RECORD
           perform SYSHEXT1-WRITE

           if  FORMAT-TYPE = 'E'
           or  FORMAT-TYPE = 'B'
               move    PASSHEX4-EBCDIC to   SYSHEXT1-RECORD
               perform SYSHEXT1-WRITE
           end-if

           exit.

      *****************************************************************
       BUILD-HEX-DUMP-INFO.
           call 'SIMOHEX4' using PASSHEX4-PASS-AREA
           exit.

      *****************************************************************
       FIRST-TIME-PROCESSING.
           perform Z-POST-COPYRIGHT
           move 'B' to FORMAT-TYPE
           if  PARM-LENGTH = 9
               inspect PARM-DATA(1:9)
                       converting LOWER-CASE to UPPER-CASE
               evaluate PARM-DATA(1:9)
                   when 'FORMAT(B)'  move 'B' to FORMAT-TYPE
                   when 'FORMAT(A)'  move 'A' to FORMAT-TYPE
                   when 'FORMAT(E)'  move 'E' to FORMAT-TYPE
               end-evaluate
           exit.

      *****************************************************************
      * I/O ROUTINES TO WRITE THE QSAM FILE FOR HEX-DUMP INFO...      *
      *****************************************************************
       SYSHEXT1-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close SYSHEXT1-FILE
           if  SYSHEXT1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'SYSHEXT1-FAILURE-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move TEXT0512-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       SYSHEXT1-WRITE.
           write SYSHEXT1-RECORD.
           if  SYSHEXT1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  TEXT0512-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'YES' to END-OF-FILE
               else
                   move 'SYSHEXT1-FAILURE-WRITE...' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move TEXT0512-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if.
           exit.
      *---------------------------------------------------------------*
       SYSHEXT1-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open output SYSHEXT1-FILE
           if  SYSHEXT1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'SYSHEXT1-FAILURE-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move TEXT0512-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * I/O ROUTINES TO READ THE KSDS, VSAM DATA SET...               *
      *****************************************************************
       TEXT0512-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close TEXT0512-FILE
           if  TEXT0512-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'TEXT0512-FAILURE-CLOSE...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move TEXT0512-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       TEXT0512-GET-NEXT.
           read TEXT0512-FILE.
           if  TEXT0512-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  TEXT0512-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'YES' to END-OF-FILE
               else
                   move 'TEXT0512-FAILURE-GET...' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move TEXT0512-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if.
           exit.
      *---------------------------------------------------------------*
       TEXT0512-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input TEXT0512-FILE
           if  TEXT0512-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'TEXT0512-FAILURE-OPEN...' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move TEXT0512-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-Routines perform administrative functions     *
      * for this program.                                             *
      *****************************************************************

      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'PROGRAM IS ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.
      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * two digits if the full two byte file status is numeric. If    *
      * second byte is non-numeric then it will be treated as a       *
      * binary number.                                                *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               move IO-STAT1 to IO-STATUS-04(1:1)
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               add TWO-BYTES-BINARY to ZERO giving IO-STATUS-0403
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move '0000' to IO-STATUS-04
               move IO-STATUS to IO-STATUS-04(3:2)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.
      *****************************************************************
      * I/O ROUTINES TO DISPLAY MESSAGES TO THE CONSOLE...            *
      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79) upon console
           else
               display MESSAGE-BUFFER upon console
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.
      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE upon console
           display SIM-COPYRIGHT upon console
           exit.
      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01 upon console
           display SIM-THANKS-02 upon console
           exit.
      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
